"{ Package: 'jv:dragonfly' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#CompiledCodeObjectTests
	instanceVariableNames:'jitEnabled'
	classVariableNames:''
	poolDictionaries:'CompiledCodeObjectSectionFormat'
	category:'System-Compiler-Interface'
!

!CompiledCodeObjectTests class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!CompiledCodeObjectTests methodsFor:'running'!

setUp
    "common setup - invoked before testing."

    super setUp.
    jitEnabled := ObjectMemory justInTimeCompilation: true.

    "Modified: / 06-12-2015 / 00:10:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

tearDown
    "common cleanup - invoked after testing."

    super tearDown.
    ObjectMemory justInTimeCompilation: jitEnabled

    "Modified: / 06-12-2015 / 00:11:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CompiledCodeObjectTests methodsFor:'test data'!

methodWithConstant
    ^ 123

    "Created: / 06-12-2015 / 00:15:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

methodWithLiteral
    ^ #(Literal 2)

    "Created: / 07-12-2015 / 16:52:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

methodWithSend
    ^ OrderedCollection size + 10

    "Created: / 07-12-2015 / 16:51:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CompiledCodeObjectTests methodsFor:'tests'!

test_01
    | object |
    self ensureCompiled: #methodWithConstant.
    object := (self class >> #methodWithConstant) codeObject.
    self assert: object compiledCode == (self class >> #methodWithConstant).
    self assert: object sections size == 2. "/ No literals no ILC's, only code and special cells
    self assert: object sections first name = '.text'.
    self assert: object sections first format = SectionFormatText.
    self assert: object sections second name = '.stx.codeobj.specialcells'.
    self assert: object sections second format = SectionTypeINTVector.


    self ensureCompiled: #methodWithLiteral.
    object := (self class >> #methodWithLiteral) codeObject.
    self assert: object sections size == 3. "/ No ILC's but literals, code and special cells


    self ensureCompiled: #methodWithSend.
    self assert: object sections size == 3. "/ No literals but ILC, code and special cells

    "Created: / 06-12-2015 / 00:15:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 11-01-2016 / 09:54:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CompiledCodeObjectTests methodsFor:'utilities'!

ensureCompiled: selector
    ((self class >> selector) code isNil or:[ (self class >> selector) byteCode isNil ]) ifTrue:[
        self class recompile: selector.
        self assert: (self class >> selector) code isNil.
        self perform: selector.
        self assert: (self class >> selector) code notNil.
    ]

    "Created: / 06-12-2015 / 00:13:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CompiledCodeObjectTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

