"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

Object subclass:#AJLineStream
	instanceVariableNames:'lineStart writeStream'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-Extension'
!

AJLineStream comment:''
!

!AJLineStream class methodsFor:'instance creation'!

on: aWriteStream 
    ^ self new 
        writeStream: aWriteStream;
        yourself
! !

!AJLineStream methodsFor:'error handling'!

doesNotUnderstand: aMessage
    writeStream 
        perform: aMessage selector 
        withArguments: aMessage arguments
! !

!AJLineStream methodsFor:'writing'!

cr
    self updateLineStart.
    writeStream cr
!

crlf
    self updateLineStart.
    writeStream crlf
!

lf
    self updateLineStart.
    writeStream lf
!

on: aStream 
    ^ self new 
        writeStream: aStream;
        yourself
!

padColumn: maxCharacterPosition
    "pad the current line up to maxCharacterPosition with spaces"
    [writeStream position - lineStart < maxCharacterPosition]
        whileTrue: [writeStream space]
!

updateLineStart
    lineStart := writeStream position
!

writeStream: aWriteStream 
    writeStream := aWriteStream.
    self updateLineStart
! !

