"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJBaseReg subclass:#AJxMMRegister
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-x86-Operands'
!

AJxMMRegister comment:'I am a register used by the SSE (Streaming SIMD Extensions) for the x86 instruction set. The independent XMM registers are 128bit wide and do not overlap with any other existing registers.

Depending on the instructions used the XMM registers represent different data types:
	SSE:  4 x 32bit single precision floats
	SSE2: 2 x 64bit double prexision floats
	      2 x 64bit integers
	      4 x 32bit integers
	      8 x 16bit short integers
	      16 x 8bit bytes/characters'
!

!AJxMMRegister methodsFor:'accessing'!

code: aCode

    code := aCode.
    size := 16
! !

!AJxMMRegister methodsFor:'printing'!

descriptionOn: s
    
    s nextPutAll: 'An SSE register'.
! !

!AJxMMRegister methodsFor:'testing'!

isGeneralPurpose
    ^ false
!

isRegTypeXMM
    ^ true
!

isX86
    ^ self index < 8
! !

